from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # characteristicCodeableConcept (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for characteristicCodeableConcept
    # Import for CodeableConcept for characteristicCodeableConcept
    from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode

    # End Import for CodeableConcept for characteristicCodeableConcept
    # characteristicQuantity (Quantity)
    from spark_auto_mapper_fhir.complex_types.quantity import Quantity

    # value (string)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class MedicationKnowledgePatientCharacteristics(FhirBackboneElementBase):
    """
    MedicationKnowledge.PatientCharacteristics
        Information about a medication that is used to support knowledge.
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        characteristicCodeableConcept: Optional[
            CodeableConcept[GenericTypeCode]
        ] = None,
        characteristicQuantity: Optional[Quantity] = None,
        value: Optional[FhirList[FhirString]] = None,
    ) -> None:
        """
        Information about a medication that is used to support knowledge.

        :param id_: id of resource
        :param extension: extensions
        :param characteristicCodeableConcept: None
        :param characteristicQuantity: None
        :param value: The specific characteristic (e.g. height, weight, gender, etc.).
        """
        super().__init__(
            id_=id_,
            extension=extension,
            characteristicCodeableConcept=characteristicCodeableConcept,
            characteristicQuantity=characteristicQuantity,
            value=value,
        )
