from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # kingdom (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for kingdom
    # Import for CodeableConcept for kingdom
    from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode

    # End Import for CodeableConcept for kingdom
    # phylum (CodeableConcept)
    # End Import for References for phylum
    # Import for CodeableConcept for phylum
    # End Import for CodeableConcept for phylum
    # class_ (CodeableConcept)
    # End Import for References for class_
    # Import for CodeableConcept for class_
    # End Import for CodeableConcept for class_
    # order (CodeableConcept)
    # End Import for References for order
    # Import for CodeableConcept for order
    # End Import for CodeableConcept for order


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class SubstanceSourceMaterialOrganismGeneral(FhirBackboneElementBase):
    """
    SubstanceSourceMaterial.OrganismGeneral
        Source material shall capture information on the taxonomic and anatomical origins as well as the fraction of a material that can result in or can be modified to form a substance. This set of data elements shall be used to define polymer substances isolated from biological matrices. Taxonomic and anatomical origins shall be described using a controlled vocabulary as required. This information is captured for naturally derived polymers ( . starch) and structurally diverse substances. For Organisms belonging to the Kingdom Plantae the Substance level defines the fresh material of a single species or infraspecies, the Herbal Drug and the Herbal preparation. For Herbal preparations, the fraction information will be captured at the Substance information level and additional information for herbal extracts will be captured at the Specified Substance Group 1 information level. See for further explanation the Substance Class: Structurally Diverse and the herbal annex.
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        kingdom: Optional[CodeableConcept[GenericTypeCode]] = None,
        phylum: Optional[CodeableConcept[GenericTypeCode]] = None,
        class_: Optional[CodeableConcept[GenericTypeCode]] = None,
        order: Optional[CodeableConcept[GenericTypeCode]] = None,
    ) -> None:
        """
            Source material shall capture information on the taxonomic and anatomical
        origins as well as the fraction of a material that can result in or can be
        modified to form a substance. This set of data elements shall be used to
        define polymer substances isolated from biological matrices. Taxonomic and
        anatomical origins shall be described using a controlled vocabulary as
        required. This information is captured for naturally derived polymers ( .
        starch) and structurally diverse substances. For Organisms belonging to the
        Kingdom Plantae the Substance level defines the fresh material of a single
        species or infraspecies, the Herbal Drug and the Herbal preparation. For
        Herbal preparations, the fraction information will be captured at the
        Substance information level and additional information for herbal extracts
        will be captured at the Specified Substance Group 1 information level. See for
        further explanation the Substance Class: Structurally Diverse and the herbal
        annex.

            :param id_: id of resource
            :param extension: extensions
            :param kingdom: The kingdom of an organism shall be specified.
            :param phylum: The phylum of an organism shall be specified.
            :param class_: The class of an organism shall be specified.
            :param order: The order of an organism shall be specified,.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            kingdom=kingdom,
            phylum=phylum,
            class_=class_,
            order=order,
        )
